# Record Class ARI1JInstrumentDescription

java.lang.Object
java.lang.Record
com.io7m.aradine.instrument.spi1.json_data.internal.ARI1JInstrumentDescription

Record Components:
  `schema` - The schema identifier
  `group` - The instrument group
  `identifier` - The unique identifier of the instrument
  `version` - The version of the instrument
  `metadata` - The metadata strings declared in the instrument description
  `parameters` - The parameters declared by the instrument
  `ports` - The ports declared by the instrument

All Implemented Interfaces:
  `ARI1JElementType`

public record ARI1JInstrumentDescription(String schema, ARI1JDottedName group, ARI1JDottedName identifier, ARI1JVersion version, Map<String,String> metadata, List<ARI1JParameterDescriptionType> parameters, List<ARI1JPortDescription> ports) extends Record implements ARI1JElementType
Create an instrument description.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ARI1JInstrumentDescription(String schema, ARI1JDottedName group, ARI1JDottedName identifier, ARI1JVersion version, Map<String,String> metadata, List<ARI1JParameterDescriptionType> parameters, List<ARI1JPortDescription> ports)`
  Create an instrument description.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `ARI1JDottedName`
  `group()`
  Returns the value of the `group` record component.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `ARI1JDottedName`
  `identifier()`
  Returns the value of the `identifier` record component.
  `Map<String,String>`
  `metadata()`
  Returns the value of the `metadata` record component.
  `List<ARI1JParameterDescriptionType>`
  `parameters()`
  Returns the value of the `parameters` record component.
  `List<ARI1JPortDescription>`
  `ports()`
  Returns the value of the `ports` record component.
  `String`
  `schema()`
  Returns the value of the `schema` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.
  `ARI1JVersion`
  `version()`
  Returns the value of the `version` record component.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### ARI1JInstrumentDescription

    public ARI1JInstrumentDescription(@JsonPropertyDescription("The schema identifier.") String schema, @JsonPropertyDescription("The instrument group.") ARI1JDottedName group, @JsonPropertyDescription("The instrument ID.") ARI1JDottedName identifier, @JsonPropertyDescription("The instrument version.") ARI1JVersion version, @JsonPropertyDescription("The instrument metadata.") Map<String,String> metadata, @JsonPropertyDescription("The instrument parameters.") List<ARI1JParameterDescriptionType> parameters, @JsonPropertyDescription("The instrument ports.") List<ARI1JPortDescription> ports)
    Create an instrument description.
    Parameters:
      `schema` - The schema identifier
      `group` - The instrument group
      `identifier` - The unique identifier of the instrument
      `version` - The version of the instrument
      `metadata` - The metadata strings declared in the instrument description
      `parameters` - The parameters declared by the instrument
      `ports` - The ports declared by the instrument

- ## Method Details

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### schema

    @JsonPropertyDescription("The schema identifier.") public String schema()
    Returns the value of the `schema` record component.
    Returns:
      the value of the `schema` record component

  - ### group

    @JsonPropertyDescription("The instrument group.") public ARI1JDottedName group()
    Returns the value of the `group` record component.
    Returns:
      the value of the `group` record component

  - ### identifier

    @JsonPropertyDescription("The instrument ID.") public ARI1JDottedName identifier()
    Returns the value of the `identifier` record component.
    Returns:
      the value of the `identifier` record component

  - ### version

    @JsonPropertyDescription("The instrument version.") public ARI1JVersion version()
    Returns the value of the `version` record component.
    Returns:
      the value of the `version` record component

  - ### metadata

    @JsonPropertyDescription("The instrument metadata.") public Map<String,String> metadata()
    Returns the value of the `metadata` record component.
    Returns:
      the value of the `metadata` record component

  - ### parameters

    @JsonPropertyDescription("The instrument parameters.") public List<ARI1JParameterDescriptionType> parameters()
    Returns the value of the `parameters` record component.
    Returns:
      the value of the `parameters` record component

  - ### ports

    @JsonPropertyDescription("The instrument ports.") public List<ARI1JPortDescription> ports()
    Returns the value of the `ports` record component.
    Returns:
      the value of the `ports` record component